'$INCLUDE: 'lib\pkglib.bi'

CONST BlockSize = 1024
DECLARE SUB BlockCopy (srcHandler AS INTEGER, dstHandler AS INTEGER, bytescount AS LONG)
DECLARE SUB RLEUnCompress (infile AS STRING, outfile AS STRING)
DECLARE SUB RLECompress (infile AS STRING, outfile AS STRING)
DECLARE SUB LZWcompress (infile AS STRING, outfile AS STRING)
DECLARE SUB LZWUnCompress (infile AS STRING, outfile AS STRING)

DECLARE SUB Init ()
DECLARE SUB DicoAdd (mystring AS STRING)
DECLARE SUB IncreaseDico ()

DECLARE SUB writeCode (Mot2%)
DECLARE FUNCTION ReadCode& ()
DECLARE FUNCTION GetCode% (w AS STRING)




TYPE ArchiveInfo
	TAG AS STRING * 2
	MajorVersion AS INTEGER
	MinorVersion AS INTEGER
	FilesCount AS INTEGER
	Descr AS STRING * 64
END TYPE

TYPE FileInfo
	Filename AS STRING * 12
	FileSize AS LONG
	CompressionMethod AS INTEGER
END TYPE
'$DYNAMIC
DIM SHARED Dico(1 TO 512) AS STRING
DIM SHARED NbrDico AS INTEGER

REM $STATIC
SUB Archive.Add (ArchiveFile AS STRING, RealFile AS STRING, aFileName AS STRING, method AS INTEGER)
	DIM Filename AS STRING
	Filename = aFileName
	IF Filename = "" THEN
		Filename = RealFile
		WHILE INSTR(Filename, "\") > 0
			Filename = MID$(Filename, INSTR(Filename, "\") + 1)
		WEND
	END IF
	IF ArchiveFile = "" THEN EXIT SUB
	SELECT CASE method
		CASE -1
			EXIT SUB
		CASE 0
			rfile$ = RealFile
			method = 0
		CASE 1
			LZWcompress RealFile, "lzw.tmp"
			rfile$ = "lzw.tmp"
			method = 1
		CASE 2
			RLECompress RealFile, "rle.tmp"
			rfile$ = "rle.tmp"
			method = 2
		CASE ELSE
			PRINT "Error: wrong method number"
			EXIT SUB
	END SELECT
	DIM Entry AS FileInfo
	DIM fic1 AS INTEGER, fic2 AS INTEGER
	IF ArchiveFile = "" THEN
		PRINT "Error: please give me the archive file name"
		EXIT SUB
	END IF
	PRINT "Adding "; Filename; "to the archive "; ArchiveFile; " ...";
	fic1 = FREEFILE
	DIM Header AS ArchiveInfo
	OPEN ArchiveFile FOR BINARY AS fic1
		GET #fic1, , Header
	CLOSE fic1
	OPEN ArchiveFile FOR BINARY AS fic1
	Header.TAG = "AR"
	Header.FilesCount = Header.FilesCount + 1
	fic2 = FREEFILE
	NbrFiles = NbrFiles + 1
	PUT #fic1, , Header
	OPEN rfile$ FOR BINARY AS fic2
		Entry.FileSize = LOF(fic2)
		Entry.CompressionMethod = method
		Entry.Filename = Filename
		SEEK (fic1), LOF(fic1) + 1
		PUT #fic1, , Entry
		BlockCopy fic2, fic1, Entry.FileSize
	CLOSE fic2
	CLOSE fic1
	IF method = 1 THEN KILL "lzw.tmp"
	IF method = 2 THEN KILL "rle.tmp"

	PRINT "Done"
END SUB

SUB Archive.ArchiveDirectory (directory AS STRING, outfile AS STRING)
	fic = FREEFILE
	IF RIGHT$(directory, 1) = "\" THEN
		mdir$ = LEFT$(directory, LEN(directory) - 1)
	ELSE
		mdir$ = directory
	END IF
	SHELL "dir " + directory + " /aa /b > filelist.tmp"
	Archive.Create outfile
	OPEN "filelist.tmp" FOR INPUT AS fic
		WHILE NOT EOF(1)
		INPUT #fic, fichier$
		Archive.Add outfile, mdir$ + "\" + fichier$, fichier$, 0
		WEND
	CLOSE fic
	KILL "filelist.tmp"

END SUB

SUB Archive.Create (ArchiveFile AS STRING)
	PRINT "Creating archive "; ArchiveFile; " ... ";
	OPEN ArchiveFile FOR BINARY AS 1: CLOSE 1
	KILL ArchiveFile
	DIM Header AS ArchiveInfo
	Header.TAG = "AR"
	Header.MajorVersion = 0
	Header.MinorVersion = 1
	Header.FilesCount = 0
	Header.Descr = ""
	OPEN ArchiveFile FOR BINARY AS 1
		PUT #1, , Header
	CLOSE 1
	PRINT "Done"
END SUB

SUB Archive.Extract (ArchiveFile AS STRING, Num AS INTEGER, outfile AS STRING)
	st$ = "st"
	SELECT CASE Num
		CASE 1: st$ = "st"
		CASE 2: st$ = "nd"
		CASE 3: st$ = "rd"
		CASE ELSE: st$ = "th"
	END SELECT
	IF Num = 0 THEN
		PRINT "Error: file number must be greather than 0"
		EXIT SUB
	END IF
       
	IF ArchiveFile = "" THEN
		PRINT "Error: please give me the archive file name"
		EXIT SUB
	END IF
	DIM fic1 AS INTEGER
	DIM fic2 AS INTEGER
	DIM NB AS INTEGER
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo

	PRINT "Extracting ";
	fic1 = FREEFILE
	OPEN ArchiveFile FOR BINARY AS fic1
	fic2 = FREEFILE
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile
	OPEN outfile FOR BINARY AS fic2
	     GET #fic1, , Header
	     NB = Header.FilesCount
	     IF NB < Num THEN
		PRINT "Error, number not in range"
		CLOSE fic1
		CLOSE fic2
		KILL outfile
		EXIT SUB
	     END IF
	     
	     FOR i = 1 TO Num - 1
		GET #fic1, , Entry
		SEEK #fic1, SEEK(fic1) + Entry.FileSize
	     NEXT i
	     GET #fic1, , Entry
	     PRINT LTRIM$(RTRIM$(Entry.Filename)) + " from "; ArchiveFile; "... ";
	     BlockCopy fic1, fic2, Entry.FileSize
	CLOSE fic2
	CLOSE fic1
	IF Entry.CompressionMethod = 1 THEN
		 LZWUnCompress outfile, "lzw.tmp"
		 KILL outfile
		 NAME "lzw.tmp" AS outfile
	END IF
	IF Entry.CompressionMethod = 2 THEN
		RLEUnCompress outfile, "rle.tmp"
		KILL outfile
		NAME "rle.tmp" AS outfile
	END IF
	PRINT "done"
END SUB

SUB Archive.ExtractAll (ArchiveFile AS STRING, directory AS STRING)
	fic = FREEFILE
	IF RIGHT$(directory, 1) = "\" THEN
		mdir$ = LEFT$(directory, LEN(directory) - 1)
	ELSE
		mdir$ = directory
	END IF
       
	NB% = Archive.FileCount(ArchiveFile)
	FOR i% = 1 TO NB%
		a$ = Archive.GetFileName(ArchiveFile, i%)
		Archive.Extract ArchiveFile, i%, mdir$ + "\" + a$
	NEXT i%
END SUB

FUNCTION Archive.FileCount% (ArchiveFile AS STRING)
	IF ArchiveFile = "" THEN EXIT FUNCTION
	fic = FREEFILE
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN ArchiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     
	     IF Header.TAG <> "AR" THEN
		PRINT "Wrong Format"
		Archive.FileCount% = 0
		EXIT FUNCTION
	     END IF
	CLOSE fic
	Archive.FileCount% = Header.FilesCount
END FUNCTION

FUNCTION Archive.GetFileName$ (ArchiveFile AS STRING, Num AS INTEGER)
	IF ArchiveFile = "" THEN EXIT FUNCTION
	IF Num < 1 THEN EXIT FUNCTION
	fic = FREEFILE
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN ArchiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     NbrFiles = Header.FilesCount
	     IF Header.TAG <> "AR" THEN
		PRINT "Wrong Format"
		Archive.GetFileName$ = ""
		EXIT FUNCTION
	     END IF
	     IF Num > Header.FilesCount THEN
		PRINT "Number out of range"
		Archive.GetFileName$ = ""
	     ELSE
				FOR i = 1 TO Num
					GET #fic, , Entry
					SEEK #fic, SEEK(fic) + Entry.FileSize
				NEXT i
				Archive.GetFileName$ = LTRIM$(RTRIM$(Entry.Filename))
	     END IF
	   
	CLOSE fic

END FUNCTION

SUB Archive.List (ArchiveFile AS STRING)
	IF ArchiveFile = "" THEN EXIT SUB
	fic = FREEFILE
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN ArchiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     NbrFiles = Header.FilesCount
	     IF Header.TAG <> "AR" THEN
		PRINT "Wrong Format"
		EXIT SUB
	     ELSE
				FOR i = 1 TO NbrFiles
					GET #fic, , Entry
					t$ = Entry.Filename
					SELECT CASE Entry.CompressionMethod
						CASE 0:
						     t$ = t$ + " ( STO )"
						CASE 1:
						     t$ = t$ + " ( LZW )"
						CASE 2:
						     t$ = t$ + " ( RLE )"
					END SELECT
					t$ = t$ + " (" + LTRIM$(RTRIM$(STR$(Entry.FileSize))) + "bytes)"
					SEEK #fic, SEEK(fic) + Entry.FileSize
					PRINT STR$(i); ": "; t$
				NEXT i
			END IF
	    
	CLOSE fic
	PRINT "Total : "; Header.FilesCount; " file(s) in the archive"
END SUB

SUB Archive.Remove (ArchiveFile AS STRING, Num AS INTEGER)
	IF Num = 0 THEN
		PRINT "Error: file number must be greather than 0"
		EXIT SUB
	END IF
      
	IF ArchiveFile = "" THEN
		PRINT "Error: please give me the archive file name"
		EXIT SUB
	END IF
       
	st$ = "st"
	SELECT CASE Num
		CASE 1: st$ = "st"
		CASE 2: st$ = "nd"
		CASE 3: st$ = "rd"
		CASE ELSE: st$ = "th"
	END SELECT

	PRINT "Removing"; STR$(Num) + st$; " file from "; ArchiveFile; "... ";

DIM fic AS INTEGER
DIM fic2 AS INTEGER
	fic = FREEFILE
	DIM NB AS INTEGER
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN ArchiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     NB = Header.FilesCount
	     IF Header.FilesCount < Num THEN
		PRINT "Error, number not in range"
		CLOSE fic
		EXIT SUB
	     END IF
	     fic2 = FREEFILE
	     OPEN "pkg.tmp" FOR BINARY AS fic2
	     Header.FilesCount = Header.FilesCount - 1
	     PUT #fic2, , Header
	     FOR i = 1 TO Num - 1
		GET #fic, , Entry
		PUT #fic2, , Entry
		BlockCopy fic, fic2, Entry.FileSize
	     NEXT i
	     GET #fic, , Entry
	     SEEK #fic, SEEK(fic) + Entry.FileSize
	     FOR i = Num + 1 TO NB
		GET #fic, , Entry
		PUT #fic2, , Entry
		BlockCopy fic, fic2, Entry.FileSize
	     NEXT i
	     CLOSE fic2
	CLOSE fic
	KILL ArchiveFile
	NAME "pkg.tmp" AS ArchiveFile
	PRINT "done"
END SUB

SUB BlockCopy (srcHandler AS INTEGER, dstHandler AS INTEGER, bytescount AS LONG)
	DIM bytes AS LONG
	bytes = bytescount
	IF bytes > LOF(srcHandler) - SEEK(srcHandler) + 1 THEN bytes = LOF(srcHandler) - SEEK(srcHandler) + 1
	NbrBlock = bytes \ BlockSize
	rest = bytes MOD BlockSize
	FOR i = 1 TO NbrBlock
		mydata$ = SPACE$(BlockSize)
		GET #srcHandler, , mydata$
		PUT #dstHandler, , mydata$
	NEXT i
	IF rest > 0 THEN
		mydata$ = SPACE$(rest)
		GET #srcHandler, , mydata$
		PUT #dstHandler, , mydata$
	END IF
END SUB

SUB DicoAdd (mystring AS STRING)
	NbrDico = NbrDico + 1
	IF NbrDico > UBOUND(Dico) THEN IncreaseDico
	Dico(NbrDico) = mystring
END SUB

FUNCTION GetCode% (w AS STRING)
	FOR i = 0 TO NbrDico
		IF Dico(i) = w THEN
		GetCode = i
		EXIT FUNCTION
		END IF
	NEXT i
	GetCode = -1
END FUNCTION

SUB IncreaseDico
	LowBound% = LBOUND(Dico)
	OldSize% = UBOUND(Dico)
	newsize% = OldSize% + 100
	
	'saving the dico
	OPEN "dico.tmp" FOR BINARY AS 3
		FOR i = LowBound% TO OldSize%
			d% = LEN(Dico(i))
			PUT #3, , d%
			PUT #3, , Dico(i)
		NEXT i
	CLOSE 3
	'resizing the dico
	REDIM Dico(LowBound% TO newsize%)   AS STRING

	'restoring the dico data
	OPEN "dico.tmp" FOR BINARY AS 3
		FOR i = LowBound% TO OldSize%
			GET #3, , d%
			Dico(i) = STRING$(d%, " ")
			GET #3, , Dico(i)
		NEXT i
	CLOSE 3
	KILL "dico.tmp"
END SUB

SUB Init
	REDIM Dico(0 TO 511)  AS STRING
	FOR i = 0 TO 255
		Dico(i) = CHR$(i)
	NEXT i
	NbrDico = 256
	bitSize = 9
END SUB

SUB LZWcompress (infile AS STRING, outfile AS STRING)
	Init
	PRINT "Compressing using LZW";
	DIM NbrBlock AS INTEGER
	DIM reste AS INTEGER
	OPEN infile FOR INPUT AS 1: CLOSE 1       'check if the input file exists
	OPEN outfile FOR BINARY AS 2: CLOSE 2: KILL outfile  'destroy the output file if exists

	DIM prefix AS STRING: prefix = ""
	DIM byte AS STRING * 1
       
	
	OPEN infile FOR BINARY AS 1
	OPEN outfile FOR BINARY AS 2
		WHILE NOT EOF(1)
			GET #1, , byte
			       
				'look the dictionary to find the string
				a% = GetCode(prefix + byte)

				'if it exist
				IF a% > -1 THEN
					prefix = prefix + byte
				ELSE
					'adding the new prefix to the dictionary
				       DicoAdd prefix + byte

				       'get the code from the old prefix
				       c% = GetCode(prefix)

				       'if its -1, sommething wrong happend
				       IF c% = -1 THEN
						LOCATE 6
						COLOR 4
						PRINT "Error string not found in dico"
						PRINT "DicoSize = "; NbrDico
						END
				       END IF

				       'output the code for the prefix
				       writeCode c%

				       'new prefix = readed byte
				       prefix = byte
				END IF
	       
	       WEND

	      'bugfix, before, it wrote 1 byte to much at the decompression
	      prefix = LEFT$(prefix, LEN(prefix) - 1)

	      'get the code for the prefix
	      c% = GetCode(prefix)

	      'output the code
	      writeCode c%

	      'output a code to be treated as end of file
	      writeCode 256
	CLOSE 2
	CLOSE 1
	ERASE Dico
	PRINT "Done"
END SUB

SUB LZWUnCompress (infile AS STRING, outfile AS STRING)
	Init
	PRINT "Uncompressing ";
	DIM byte AS INTEGER
	DIM w AS STRING
	DIM entree AS STRING
	OPEN infile FOR INPUT AS 1: CLOSE 1     'check if input file exists
	OPEN outfile FOR BINARY AS 2: CLOSE 2: KILL outfile 'destroy output file if exists
	
	OPEN infile FOR BINARY AS 1
	OPEN outfile FOR BINARY AS 2
	       
			       
		'read the code
		byte = ReadCode&

		'the first byte is the first character in the decompressed file
		c$ = CHR$(byte)
		PUT #2, , c$
		w = c$


		DO

			'read the code, it will be the index of the string in the dictionary
			byte = ReadCode&
		       
			'end of file occurs
			IF byte = 256 THEN
				EXIT DO
			END IF

			'the byte represent a string
			IF (byte > 255) THEN
				'if its in the dico
				IF (byte <= NbrDico) THEN
					'get the string
					entree = Dico(byte)
				ELSE
					'usign the previous string
					entree = w + LEFT$(w, 1)
				END IF
			ELSE
			    'the byte is a normal character
			    entree = CHR$(byte)
			END IF

			'output the result to the out file
			PUT #2, , entree

			'add the entry to the dico
			DicoAdd w + LEFT$(entree, 1)

			'new string
			w = entree
		LOOP WHILE NOT EOF(1)
	CLOSE 2
	CLOSE 1
	ERASE Dico
	PRINT "Done !"
END SUB

FUNCTION ReadCode&
	STATIC Bit%
	STATIC N1 AS LONG
	DIM N2 AS LONG

	IF Bit% = 0 THEN a$ = "   ": GET #1, , a$: N1 = CVL(a$ + CHR$(0))
	N2 = 0
	FOR a% = 0 TO 11 STEP 1
		N2 = N2 + (N1 AND 2 ^ (a% + Bit%)) / (2 ^ Bit%)
	NEXT a%
	Bit% = -(Bit% = 0) * 12
	ReadCode& = N2

END FUNCTION

SUB RLECompress (infile AS STRING, outfile AS STRING)
	PRINT "Compressing using RLE ";
	DIM counter AS INTEGER
	DIM char AS STRING * 1
	DIM oldbyte AS STRING * 1
	DIM outdata AS STRING
	fic = FREEFILE
	OPEN infile FOR INPUT AS fic: fic2 = FREEFILE: CLOSE fic  'check if input file exists
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile 'destroy output file if exists
	OPEN infile FOR BINARY AS fic
	OPEN outfile FOR BINARY AS fic2

	NbrBlock = (LOF(fic) - 1) \ BlockSize
	rest = (LOF(fic) - 1) MOD BlockSize
	DIM index AS LONG: index = 0
	GET #fic, , char
	oldbyte = char
	outdata = ""
	counter = 1
	WHILE NOT EOF(fic)
		GET #fic, , char
		IF char <> oldbyte THEN
			d$ = CHR$(counter)
			PUT #fic2, , d$
			PUT #fic2, , oldbyte
			oldbyte = char
			counter = 1
		ELSE
			counter = counter + 1
			IF counter > 255 THEN
			  d$ = CHR$(255)
			  PUT #fic2, , d$
			  PUT #fic2, , oldbyte
			  counter = 1
			END IF
		END IF

	WEND
	CLOSE fic2
	CLOSE fic
	PRINT "Done"
END SUB

SUB RLEUnCompress (infile AS STRING, outfile AS STRING)
	PRINT "Uncompressing ";
	fic = FREEFILE
	OPEN infile FOR INPUT AS fic: fic2 = FREEFILE: CLOSE fic    'check if the input file exists
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile  'destroy the output file if exists
	OPEN infile FOR BINARY AS fic
	DIM index AS LONG: index = 0
	OPEN outfile FOR BINARY AS fic2
		WHILE NOT EOF(fic)
			m$ = " ": n$ = " "
			GET #fic, , m$
			GET #fic, , n$
			t$ = STRING$(ASC(m$), n$)
			PUT #fic2, , t$
			l& = l& + ASC(m$)
		WEND
	CLOSE fic2
	CLOSE fic
	PRINT "Done"
END SUB

SUB writeCode (Mot2%)
DIM n AS LONG
STATIC Mot1%

  IF Mot1% = 0 THEN
	IF Mot2% = 256 THEN
		c$ = CHR$(0) + CHR$(1)
		PUT #2, , c$
		EXIT SUB
	ELSE
		Mot1% = Mot2% + 1
		EXIT SUB
	END IF
  ELSE
    n = (Mot1% - 1) + Mot2% * (2 ^ 12)
    c$ = ""
    FOR a = 0 TO 2
      c$ = c$ + CHR$((n AND (255 * 2 ^ (a * 8))) / 2 ^ (a * 8))
    NEXT a
    PUT #2, , c$
    Mot1% = 0
  END IF
 

END SUB

