'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\itemlist.bi'

SUB Draw.CheckBoxList (this AS ItemList, items() AS ListItem)
	MouseHide
	
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF this.MaxWidth <> -1 THEN IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	IF this.MinWidth <> -1 THEN IF maxlen < this.MinWidth THEN maxlen = this.MinWidth
	FOR i = LBOUND(items) TO UBOUND(items)
		x = (i - LBOUND(items)) MOD this.cols
		y = (i - LBOUND(items)) \ this.cols
		x1 = this.x1 + x * (maxlen * 8) + 10
		y1 = this.y1 + 10 * y
		LINE (x1, y1)-(x1 + 6, y1 + 8), BorderColor2, BF
		LINE (x1 + 1, y1 + 1)-(x1 + 5, y1 + 7), BgColor, BF
		IF (items(i).selected) THEN
			LINE (x1 + 2, y1 + 2)-(x1 + 4, y1 + 6), SelectBgColor, BF
		END IF
		Draw.Text LTRIM$(RTRIM$(items(i).text)), x1 + 10, y1 + 1, TextColor, -1
	NEXT i
	MouseShow
END SUB

SUB Draw.ItemList (this AS ItemList, items() AS ListItem)
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	IF maxlen < this.MinWidth AND this.MinWidth > 0 THEN maxlen = this.MinWidth
	    Initx.Button this.UpBtn, CHR$(30), this.x1, this.y1 - 12, this.x1 + (maxlen * 8 + 4) * this.cols, this.y1 - 1
	    Initx.Button this.DownBtn, CHR$(31), this.x1, this.y1 + 10 * this.rows, this.x1 + (maxlen * 8 + 4) * this.cols, this.y1 + 11 + 10 * this.rows
       
	MouseHide
	LINE (this.UpBtn.x1 - 1, this.UpBtn.y1)-(this.UpBtn.x2 + 1, this.DownBtn.y2), BgColor, BF
	LINE (this.UpBtn.x1 - 1, this.UpBtn.y2)-(this.UpBtn.x2 + 1, this.DownBtn.y1), BOrderColor1, B
	overlay = this.maxitems < ((UBOUND(items) - LBOUND(items)) + 1)
	IF overlay THEN
	    Draw.Button this.UpBtn
	    Draw.Button this.DownBtn
	END IF
	max = this.maxitems
	IF NOT overlay THEN max = UBOUND(items) - LBOUND(items) + 1
	IF max + this.FirstItem + LBOUND(items) - 1 > UBOUND(items) THEN
		max = (UBOUND(items) - LBOUND(items) + 1) - this.FirstItem
	END IF
	
	FOR i = 0 TO max - 1
		x = i MOD this.cols
		y = i \ this.cols

		x1 = this.x1 + x * ((maxlen * 8) + 4)
		y1 = this.y1 + 10 * y
		x2 = x1 + (maxlen * 8) + 4
		y2 = y1 + 9
		Texte$ = LTRIM$(RTRIM$(items(i + this.FirstItem + LBOUND(items)).text))
		IF LEN(Texte$) > this.MaxWidth THEN Texte$ = LEFT$(Texte$, this.MaxWidth - 3) + "..."
		IF (items(i + this.FirstItem + LBOUND(items)).selected) THEN
			LINE (x1, y1)-(x2, y2), SelectBgColor, BF
			Draw.Text Texte$, x1 + 2, y1 + 1, SelectTextColor, -1
		ELSE
			LINE (x1, y1)-(x2, y2), BgColor, BF
			Draw.Text Texte$, x1 + 2, y1 + 1, TextColor, -1
		END IF
	NEXT i
	MouseShow
END SUB

SUB Draw.RadioBUttonList (this AS ItemList, items() AS ListItem)
	MouseHide
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF this.MaxWidth <> -1 THEN IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	IF this.MinWidth <> -1 THEN IF maxlen < this.MinWidth THEN maxlen = this.MinWidth
       
	FOR i = LBOUND(items) TO UBOUND(items)
		x = (i - LBOUND(items)) MOD this.cols
		y = (i - LBOUND(items)) \ this.cols
		x1 = this.x1 + x * (maxlen * 8) + 10
		y1 = this.y1 + 10 * y
		CIRCLE (x1 + 3, y1 + 3), 3, 15
		PAINT (x1 + 3, y1 + 3), 15
		IF (items(i).selected) THEN
			CIRCLE (x1 + 3, y1 + 3), 2, 10
			PAINT (x1 + 3, y1 + 3), 10
		END IF
		CIRCLE (x1 + 3, y1 + 3), 3, 0

		Draw.Text LTRIM$(RTRIM$(items(i).text)), x1 + 10, y1 + 1, 0, -1
	NEXT i
	MouseShow

END SUB

SUB Init.ItemLIst (this AS ItemList, x1 AS INTEGER, y1 AS INTEGER, cols AS INTEGER, rows AS INTEGER)
	this.x1 = x1
	this.y1 = y1
	this.cols = cols
	this.rows = rows
	this.maxitems = rows * cols
	this.MaxWidth = 20
END SUB

SUB Manage.CheckBoxList (this AS ItemList, items() AS ListItem)
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	this.SelectionChanged = 0
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF this.MaxWidth <> -1 THEN IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	IF this.MinWidth <> -1 THEN IF maxlen < this.MinWidth THEN maxlen = this.MinWidth
	FOR i = LBOUND(items) TO UBOUND(items)
		x = (i - LBOUND(items)) MOD this.cols
		y = (i - LBOUND(items)) \ this.cols
		x1 = this.x1 + x * (maxlen * 8) + 10
		y1 = this.y1 + 10 * y
		x2 = x1 + 6
		y2 = y1 + 6
		IF MouseZOne(x1, y1, x2, y2) AND MouseClicLeft THEN
			DO
			LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
			IF MouseZOne(x1, y1, x2, y2) THEN
				items(i).selected = NOT items(i).selected
				Draw.CheckBoxList this, items()
				this.SelectionChanged = -1
				this.SelectedIndex = i
			END IF
		END IF
	NEXT i

END SUB

SUB Manage.ItemList (this AS ItemList, items() AS ListItem)
	this.SelectionChanged = 0
	this.Draged = 0
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	overlay = this.maxitems < ((UBOUND(items) - LBOUND(items)) + 1)
	IF overlay THEN
		IF Click.Button(this.UpBtn) AND this.FirstItem > 0 THEN
			this.FirstItem = this.FirstItem - this.cols
			IF this.maxitems = 1 THEN
				FOR j = LBOUND(items) TO UBOUND(items)
					items(j).selected = 0
				NEXT j
				items(this.FirstItem + LBOUND(items)).selected = -1
				this.SelectionChanged = -1
				this.SelectedText = LTRIM$(RTRIM$(items(this.FirstItem + LBOUND(items)).text))
			END IF
			Draw.ItemList this, items()
		END IF
		IF Click.Button(this.DownBtn) AND this.maxitems < ((UBOUND(items) - LBOUND(items)) + 1) - this.FirstItem THEN
			this.FirstItem = this.FirstItem + this.cols
			IF this.maxitems = 1 THEN
				FOR j = LBOUND(items) TO UBOUND(items)
					items(j).selected = 0
				NEXT j
				items(this.FirstItem + LBOUND(items)).selected = -1
				this.SelectionChanged = -1
				this.SelectedText = LTRIM$(RTRIM$(items(this.FirstItem + LBOUND(items)).text))
			END IF
			Draw.ItemList this, items()
		END IF
	END IF
	max = this.maxitems
	IF NOT overlay THEN max = UBOUND(items) - LBOUND(items) + 1
	IF max + this.FirstItem + LBOUND(items) - 1 > UBOUND(items) THEN
		max = (UBOUND(items) - LBOUND(items) + 1) - this.FirstItem
	END IF
	FOR i = 0 TO max - 1
		x = i MOD this.cols
		y = i \ this.cols

		x1 = this.x1 + x * ((maxlen * 8) + 4)
		y1 = this.y1 + 10 * y
		x2 = x1 + (maxlen * 8) + 4
		y2 = y1 + 9
		IF MouseZOne(x1, y1, x2, y2) AND MouseClicLeft THEN
			IF this.Dragable THEN
				GOTO DragItemList
			ELSE
				GOTO NoDrag
			END IF
		END IF
	NEXT i
       EXIT SUB



NoDrag:

			DO
			LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
			IF MouseZOne(x1, y1, x2, y2) THEN
				FOR j = LBOUND(items) TO UBOUND(items)
					items(j).selected = 0
				NEXT j
				items(i + this.FirstItem + LBOUND(items)).selected = -1
				this.SelectionChanged = -1
				this.SelectedText = LTRIM$(RTRIM$(items(i + this.FirstItem + LBOUND(items)).text))
				this.SelectedIndex = i + this.FirstItem + LBOUND(items)
				Draw.ItemList this, items()
			END IF
EXIT SUB

DragItemList:
	newx = 0
	newy = 0
	t$ = LTRIM$(RTRIM$(items(i + this.FirstItem + LBOUND(items)).text))
	IF DragDrop(x1, y1, x2, y2, newx%, newy%, t$) THEN
		this.Draged = -1
		this.DragedIndex = i + this.FirstItem + LBOUND(items)
		this.DragedText = LTRIM$(RTRIM$(items(i + this.FirstItem + LBOUND(items)).text))
		this.DragX = MouseX
		this.DragY = MouseY
	ELSE
				this.Draged = 0
				FOR j = LBOUND(items) TO UBOUND(items)
					items(j).selected = 0
				NEXT j
				items(i + this.FirstItem + LBOUND(items)).selected = -1
				this.SelectionChanged = -1
				this.SelectedText = LTRIM$(RTRIM$(items(i + this.FirstItem + LBOUND(items)).text))
				Draw.ItemList this, items()
       
	END IF
EXIT SUB
END SUB

SUB Manage.RadioBUttonList (this AS ItemList, items() AS ListItem)
	this.SelectionChanged = 0
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	maxlen = 0
	FOR i = LBOUND(items) TO UBOUND(items)
		IF maxlen < LEN(LTRIM$(RTRIM$(items(i).text))) THEN maxlen = LEN(LTRIM$(RTRIM$(items(i).text)))
	NEXT i
	IF this.MaxWidth <> -1 THEN IF maxlen > this.MaxWidth THEN maxlen = this.MaxWidth
	IF this.MinWidth <> -1 THEN IF maxlen < this.MinWidth THEN maxlen = this.MinWidth
	FOR i = LBOUND(items) TO UBOUND(items)
		x = (i - LBOUND(items)) MOD this.cols
		y = (i - LBOUND(items)) \ this.cols
		x1 = (this.x1 + x * (maxlen * 8) + 10) - 3
		y1 = (this.y1 + 10 * y) - 3
		x2 = x1 + 6
		y2 = y1 + 6
		IF MouseZOne(x1, y1, x2, y2) AND MouseClicLeft THEN
			DO
			LOOP UNTIL NOT (MouseZOne(x1, y1, x2, y2) AND MouseClicLeft)
			IF MouseZOne(x1, y1, x2, y2) THEN
				FOR j = LBOUND(items) TO UBOUND(items)
					items(j).selected = 0
				NEXT j
				items(i).selected = -1
				this.SelectionChanged = -1
				this.SelectedText = LTRIM$(RTRIM$(items(i).text))
				this.SelectedIndex = i
				Draw.RadioBUttonList this, items()
			END IF
		END IF
	NEXT i

END SUB

