DECLARE SUB MouseShow ()
DECLARE SUB MouseHide ()
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\textbox.bi'

SUB Draw.TextBox (this AS TextBox)
	MouseHide
	display$ = LEFT$(this.text, this.textlen)
	c1% = BorderColor2
	c2% = TextColor
	IF this.focus THEN
		display$ = display$ + "_"
		c1% = BorderColor1
		c2% = BorderColor1
	END IF
       
	IF LEN(display$) > this.maxlen THEN display$ = RIGHT$(display$, this.maxlen)
	LINE (this.x1, this.y1)-(this.x2, this.y2), BGColor, BF
	LINE (this.x1, this.y1)-(this.x2, this.y2), c1%, B
	Draw.Text display$, this.x1 + 2, this.y1 + 2, c2%, -1
	MouseShow
END SUB

SUB Init.TextBox (this AS TextBox, x1, y1, maxlen)
	this.text = ""
	this.x1 = x1
	this.y1 = y1
	this.x2 = x1 + maxlen * 8 + 4
	this.y2 = y1 + 12
	this.maxlen = maxlen
END SUB

SUB Manage.TextBox (this AS TextBox)
	this.TextChanged = 0
	IF MouseZOne(this.x1, this.y1, this.x2, this.y2) AND MouseClicLeft THEN
		this.focus = -1
		Draw.TextBox this
		oldtext$ = LEFT$(this.text, this.textlen)
		oldlen = this.textlen
		this.TextChanged = 0
		DO
			key$ = INKEY$
			IF key$ <> "" THEN
				SELECT CASE key$
					CASE CHR$(27)
						this.text = oldtext$
						this.textlen = oldlen
						EXIT DO
					CASE CHR$(13)
						this.TextChanged = -1
						EXIT DO
					CASE CHR$(8)
						IF this.textlen > 0 THEN
							this.textlen = this.textlen - 1
							this.text = LEFT$(this.text, this.textlen)
							Draw.TextBox this
						END IF
					CASE ELSE
						IF ASC(key$) > 25 THEN
							this.text = LEFT$(this.text, this.textlen) + key$
							this.textlen = this.textlen + 1
							Draw.TextBox this
						END IF
				END SELECT
			END IF
		     IF MouseClicLeft AND NOT MouseZOne(this.x1, this.y1, this.x2, this.y2) THEN
			this.TextChanged = -1
			EXIT DO
		     END IF
		LOOP
		this.focus = 0
		Draw.TextBox this
	END IF
END SUB

