DECLARE SUB Draw.Wall ()
DECLARE SUB LoadConfig ()
DECLARE SUB SaveConfig ()
DECLARE SUB Preview ()
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\locale.bi'

'ON ERROR GOTO catch
'$DYNAMIC
DIM SHARED rep AS INTEGER
App.SetTitle (Localize("colors.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtExit"))
GUI.Init
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED Colors(1 TO 6) AS INTEGER
DIM SHARED LIstLanguage AS ItemLIst
DIM SHARED LangData(0 TO 0) AS ListItem


wx = 260
wy = 310
wx1 = (xres - wx) \ 2
wy1 = (yres - wy) \ 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1

LoadConfig
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("colors.str", "txtTitle")
Init.ItemLIst LIstLanguage, wx2 - 80, wy1 + 100 + (yres \ 3), 1, 3
LIstLanguage.MinWidth = 8
LIstLanguage.MaxWidth = 8


Preview
GOSUB DrawOptions

MouseShow
DO
	GOSUB ManageOptions
	App.Manage
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			SaveConfig
			app.Exit
	       
		CASE Localize("system.str", "txtExit")
			SaveConfig
			app.Exit
	END SELECT
	END IF
LOOP

DrawOptions:
	MouseHide
	LINE (wx1 + 5, wy1 + 20 + (yres \ 3))-(wx2 - 5, wy2 - 5), BgColor, BF
	Draw.Text Localize("colors.str", "txtOptBg"), wx1 + 5, wy1 + 25 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptBord1"), wx1 + 5, wy1 + 35 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptBord2"), wx1 + 5, wy1 + 45 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptText"), wx1 + 5, wy1 + 55 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptSelBg"), wx1 + 5, wy1 + 65 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptSelText"), wx1 + 5, wy1 + 75 + (yres \ 3), TextColor, -1
	Draw.Text Localize("colors.str", "txtOptSelLang"), wx1 + 5, wy1 + 100 + (yres \ 3), TextColor, -1
	FOR i = 1 TO 6
	LINE (wx2 - 70, wy1 + (i * 10) + 15 + (yres \ 3))-(wx2 - 10, wy1 + (i * 10) + 23 + (yres \ 3)), Colors(i), BF
	LINE (wx2 - 70, wy1 + (i * 10) + 15 + (yres \ 3))-(wx2 - 10, wy1 + (i * 10) + 23 + (yres \ 3)), 0, B
	NEXT i
	Draw.ItemList LIstLanguage, LangData()
	MouseShow
RETURN

ManageOptions:
	      FOR i = 1 TO 6
		IF MouseClicLeft AND MouseZOne(wx2 - 70, wy1 + (i * 10) + 15 + (yres \ 3), wx2 - 10, wy1 + (i * 10) + 23 + (yres \ 3)) THEN
			DO: LOOP UNTIL NOT MouseClicLeft
			c = SelectColor
			IF c > -1 THEN
				Colors(i) = c
				Preview
				GOSUB DrawOptions
			END IF
	       
		END IF
	      NEXT i
	Manage.ItemList LIstLanguage, LangData()
RETURN
catch:
	rep = 0
	RESUME NEXT

REM $STATIC
SUB Draw.Wall
	SCREEN 12
	LoadConfig
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	MouseHide
	LINE (0, 0)-(639, 479), Colors(1), BF
	MouseShow

END SUB

SUB LoadConfig
	Colors(1) = BgColor
	Colors(2) = BorderColor1
	Colors(3) = BorderColor2
	Colors(4) = TextColor
	Colors(5) = SelectBgColor
	Colors(6) = SelectTextColor
	selectedlang$ = RegRead("desktop:lang")
	SHELL "dir lang /ad /b>out.tmp"
	fic = FREEFILE
	OPEN "out.tmp" FOR INPUT AS fic
	Nbrlang = 0
	WHILE NOT EOF(fic)
		INPUT #fic, lng$
		IF LEFT$(lng$, 1) <> "." THEN Nbrlang = Nbrlang + 1
	WEND
	CLOSE fic
	IF Nbrlang = 0 THEN
		REDIM LangData(0 TO 0) AS ListItem
		LangData(0).text = "en"
		LangData(0).selected = -1
		LIstLanguage.SelectedIndex = 0
	ELSE
	 REDIM LangData(0 TO Nbrlang - 1) AS ListItem
	OPEN "out.tmp" FOR INPUT AS fic
	Nbrlang = 0
	WHILE NOT EOF(fic)
	       
		INPUT #fic, lng$
		IF LEFT$(lng$, 1) <> "." THEN
			LangData(Nbrlang).text = lng$
			LangData(Nbrlang).selected = LTRIM$(RTRIM$(LCASE$(lng$))) = LTRIM$(RTRIM$(LCASE$(selectedlang$)))
			IF LangData(Nbrlang).selected THEN LIstLanguage.SelectedIndex = Nbrlang
			Nbrlang = Nbrlang + 1
		END IF
	WEND
       CLOSE fic
       END IF
       KILL "out.tmp"
       
END SUB

SUB Preview
	DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER
	MouseHide
	largeur = xres \ 3
	hauteur = yres \ 3
	x1 = (xres \ 2) - (largeur \ 2)
	y1 = wy1 + 5
	x2 = x1 + largeur - 1
	y2 = y1 + hauteur - 1
	LINE (x1, y1)-(x2, y2), Colors(1), BF
	LINE (x1, y1)-(x2, y2), 0, B
	LINE (x1, y1)-(x1 + 40, y1 + 10), Colors(2), B
	LINE (x1 + 41, y1)-(x1 + 41, y1 + 11), Colors(3)
	LINE -(x1, y1 + 11), Colors(3)
       
	LINE (x1 + 42, y1)-(x2 - 13, y1 + 10), Colors(2), B
	LINE (x2 - 12, y1)-(x2 - 12, y1 + 11), Colors(3)
	LINE -(x1 + 42, y1 + 11), Colors(3)


	LINE (x2 - 11, y1)-(x2 - 1, y1 + 10), Colors(2), B
	LINE (x2, y1)-(x2, y1 + 11), Colors(3)
	LINE -(x2 - 11, y1 + 11), Colors(3)

	LINE (x1 + 5, y1 + 20)-(x1 + 150, y1 + 80), Colors(1), BF
	LINE (x1 + 5, y1 + 20)-(x1 + 149, y1 + 79), Colors(2), B
	LINE (x1 + 150, y1 + 20)-(x1 + 150, y1 + 80), Colors(3)
	LINE -(x1 + 5, y1 + 80), Colors(3)
	LINE (x1 + 8, y1 + 35)-(x1 + 147, y1 + 77), Colors(2), B
       
	Draw.Text Localize("colors.str", "txtPreviewSel"), x1 + 23, y1 + 40, Colors(6), Colors(5)
	Draw.Text Localize("colors.str", "txtPreviewWin"), x1 + 8, y1 + 23, Colors(4), Colors(1)
	MouseShow
END SUB

SUB SaveConfig
	RegWrite "desktop:bgColor", STR$(Colors(1))
	RegWrite "desktop:BorderColor1", STR$(Colors(2))
	RegWrite "desktop:BorderColor2", STR$(Colors(3))
	RegWrite "desktop:TextColor", STR$(Colors(4))
	RegWrite "desktop:SelectBgColor", STR$(Colors(5))
	RegWrite "desktop:SelectTextColor", STR$(Colors(6))
	RegWrite "desktop:lang", LTRIM$(RTRIM$(LangData(LIstLanguage.SelectedIndex).text))
END SUB

